Unit Files;

{Programmer: Argon D. Helm
 Sample Plug-in for Excalibur.
 The Author assumes no reponsibility for anything
 that you do or anything that happens when using
 the code in this plug.
 Use and distribute as you please.}

 {MODIFIED TO USE AlSetPointer and AlGetPointer to show how to
  pass data bettween routines without declaring global variables.}

  {Note: AlLock and AlUnlock may or may not be nessesary in all cases.
         you'll wan't to play with them to find out.}

Interface

uses
  SysUtils, WinTypes, Alchm;


{To expand this record:
 1. Add valid fields to it.
 2. Change the filter string in PlugProcess
 3  Update the relevant sections of PlugData.}

type PFileData = ^TFileData;
     TFileData = record
      FileName: array[0..255] of Char;
end;

const MaxFileRecsPerSend = 65530 div SizeOf(TFileData);

function  PlugDialog(SlotH: LPSLOT; uResult: WORD):WORD; export;
function  PlugData(SlotH: LPSLOT; more: BOOL; data: LPVOID):BOOL; export;
function  PlugUnique(SlotH: LPSLOT; args, cMessage: PChar):BOOL; export;
procedure PlugDestroy(SlotH: LPSLOT); export;
function  PlugButton(SlotH: LPSLOT; id: WORD):WORD; export;
function  PlugMouse(SlotH: LPSLOT; code: BYTE; x, y: WORD):BOOL; export;
function  PlugType(SlotH: LPSLOT; title: PChar):WORD; export;
function  PlugProcess(SlotH: LPSLOT):WORD; export;

implementation

{$R FILES.RES}

(*------------------------------------------------------------------*)
function  PlugDialog(SlotH: LPSLOT; uResult: WORD):WORD;
begin
   Result := AL_DIE; 
end;

(*------------------------------------------------------------------*)
function  PlugData(SlotH: LPSLOT; more: BOOL; data: LPVOID):BOOL;
var i: Integer;
    Count: LongInt;
    FileData: PFileData;
    SafePointer: LPVOID;
begin
    SafePointer := data;
    Move(SafePointer^, Count, SizeOf(LongInt));

     if (Count > 0) and (Count < MaxFileRecsPerSend) then
      begin
       Inc(PByte(SafePointer), SizeOf(LongInt));
        for i := 0 to Count - 1 do
         begin
          AlLbAddString(SlotH, 13, PFileData(SafePointer)^.FileName);
          Inc(PByte(SafePointer), SizeOf(TFileData));
         end;
      end else AlLbAddString(SlotH, 13, 'No Files for Requested Libary.');
 AlExecDialog(SlotH);
 Result := True;
end;

(*------------------------------------------------------------------*)
function  PlugUnique(SlotH: LPSLOT; args, cMessage: PChar):BOOL;
begin
     Result := False;
end;

(*------------------------------------------------------------------*)
procedure PlugDestroy(SlotH: LPSLOT);
begin

end;

(*------------------------------------------------------------------*)
function  PlugButton(SlotH: LPSLOT; id: WORD):WORD;
begin
     Result := AL_OK;
end;

(*------------------------------------------------------------------*)
function  PlugMouse(SlotH: LPSLOT; code: BYTE; x, y: WORD):BOOL;
begin
    Result := BOOL(AL_OK);
end;

(*------------------------------------------------------------------*)
function  PlugType(SlotH: LPSLOT; title: PChar):WORD;
begin
   Result := AL_WIN_HIDDEN;
end;

(*------------------------------------------------------------------*)
function  PlugProcess(SlotH: LPSLOT):WORD;
var TheId: Array[0..30] of Char;
    PlugArgs: array[0..9] of Char;
begin
        StrPCopy(TheId, 'libid==');
        AlArgs(SlotH, PlugArgs, 9);
        StrCat(TheId, PlugArgs);

        {Request grail data to place info in the other UserData Fields}
        AlGrailRequest(SlotH, 'file', 'name', TheId);

        AlLoadDialog(SlotH, 'DIALOG_1', HInstance);

 Result := AL_OK;
end;

end.
